
//  T0.9_Vector_STL.cpp

//         STL .
//      ,      . 
//      ,      .

#include <iostream>
#include <vector>		 //    <vector>
using namespace std;

class Demo {             //    Demo
private:
  double d;              // -   double 
public:
  Demo() { d = 0.0; }	 //   
  Demo(double x) { d = x; }    // 
// -        Demo
  Demo &operator=(double x) {
    d = x; return *this; //     this
  }

  double getd() { return d; }  // -- double
};

bool operator<(Demo a, Demo b) //    <
{
  return a.getd() < b.getd();
}

bool operator==(Demo a, Demo b) //    ==
{
  return a.getd() == b.getd();
}

int main()
{
  vector<Demo> v;
  int i;

  for(i=0; i<10; i++)
    v.push_back(Demo(i/3.0));  //     

  for(i=0; i<v.size(); i++)
    cout << v[i].getd() << " ";//    
  cout << endl;

  for(i=0; i<v.size(); i++)
    v[i] = v[i].getd() * 2.1;  //     

  for(i=0; i<v.size(); i++)
    cout << v[i].getd() << "  ";//    
  cout << endl; system("PAUSE");
  return 0;
}
